Help us improve by taking our short survey: https://www.hdfgroup.org/website-survey/

| HDF5 Last Updated on 2026-03-23 The HDF5 Field Guide

Loading...
Searching...
No Matches
ObjCreatPropList Class Reference

`#include <c++/src/H5OcreatProp.h>`

## Detailed Description

Class ObjCreatPropList inherits from PropList and provides wrappers for the HDF5 object create property list.

Inheritance diagram for ObjCreatPropList:

## Public Member Functions
virtual std::string | fromClass () const override
| Returns this class name.
unsigned | getAttrCrtOrder () const
| Returns the flags indicating creation order is tracked/indexed for attributes on an object.
void | getAttrPhaseChange (unsigned &max_compact, unsigned &min_dense) const
| Gets attribute storage phase change thresholds.
| ObjCreatPropList ()
| Creates a file access property list.
| ObjCreatPropList (const hid_t plist_id)
| Creates a file access property list using the id of an existing one.
| ObjCreatPropList (const ObjCreatPropList &original)
| Copy constructor: same HDF5 object as original.
void | setAttrCrtOrder (unsigned crt_order_flags) const
| Set the flags for creation order of attributes on an object.
void | setAttrPhaseChange (unsigned max_compact=8, unsigned min_dense=6) const
| Sets attribute storage phase change thresholds.
virtual | ~ObjCreatPropList () override=default
Public Member Functions inherited from PropList
virtual void | close () override
| Closes the property list if it is not a default one.
void | closeClass () const
| Close a property list class.
void | copy (const PropList &like_plist)
| Makes a copy of an existing property list.
void | copyProp (PropList &dest, const char *name) const
| Copies a property from this property list or class to another.
void | copyProp (PropList &dest, const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | copyProp (PropList &dest, PropList &src, const char *name) const
| Copies a property from one list or class to another - Obsolete.
void | copyProp (PropList &dest, PropList &src, const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts. - Obsolete.
hid_t | getClass () const
| Returns the class of this property list, i.e. `H5P_FILE_CREATE`...
std::string | getClassName () const
| Return the name of a generic property list class.
PropList | getClassParent () const
| Returns the parent class of a generic property class.
virtual hid_t | getId () const override
| Get the id of this property list.
size_t | getNumProps () const
| Returns the number of properties in this property list or class.
std::string | getProperty (const char *name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | getProperty (const char *name, void *value) const
| Query the value of a property in a property list.
std::string | getProperty (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | getProperty (const std::string &name, void *value) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
size_t | getPropSize (const char *name) const
| Query the size of a property in a property list or class.
size_t | getPropSize (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
bool | isAClass (const PropList &prop_class) const
| Determines whether a property list is a certain class.
PropList & | operator= (const PropList &rhs)
| Assignment operator.
bool | operator== (const PropList &rhs) const
| Compares this property list or class against the given list or class.
bool | propExist (const char *name) const
| Query the existence of a property in a property object.
bool | propExist (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
| PropList ()
| Default constructor: creates a stub property list object.
| PropList (const hid_t plist_id)
| Creates a property list using the id of an existing property.
| PropList (const PropList &original)
| Copy constructor: same HDF5 object as original.
void | removeProp (const char *name) const
| Removes a property from a property list.
void | removeProp (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const char *name, const char *charptr) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const char *name, const std::string &strg) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const char *name, const void *value) const
| Set a property's value in a property list.
void | setProperty (const char *name, std::string &strg) const
| Deprecated due to missing const in prototype. (1.10.1).
void | setProperty (const char *name, void *value) const
| Deprecated due to missing const in prototype. (1.10.1).
void | setProperty (const std::string &name, const std::string &strg) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const std::string &name, const void *value) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const std::string &name, std::string &strg) const
| Deprecated due to missing const in prototype. (1.10.1).
void | setProperty (const std::string &name, void *value) const
| Deprecated due to missing const in prototype. (1.10.1).
virtual | ~PropList () override
| Properly terminates access to this property list.
Public Member Functions inherited from IdComponent
void | decRefCount () const
| Decrement reference counter for the id of this object.
void | decRefCount (const hid_t obj_id) const
| Decrement reference counter for a given id.
int | getCounter () const
| Returns the reference counter for the id of this object.
int | getCounter (const hid_t obj_id) const
| Returns the reference counter for a given id.
H5I_type_t | getHDFObjType () const
| Returns the type of the object. It is an overloaded function of the above function.
void | incRefCount () const
| Increment reference counter for the id of this object.
void | incRefCount (const hid_t obj_id) const
| Increment reference counter for a given id.
std::string | inMemFunc (const char *func_name) const
| Makes and returns string "<class-name>::<func_name>".
IdComponent & | operator= (const IdComponent &rhs)
| Assignment operator.
void | setId (const hid_t new_id)
| Sets the identifier of this object to a new value.
virtual | ~IdComponent ()=default

## Static Public Member Functions
static void | deleteConstants ()
Static Public Member Functions inherited from PropList
static void | deleteConstants ()
Static Public Member Functions inherited from IdComponent
static H5I_type_t | getHDFObjType (const hid_t obj_id)
| Given an id, returns the type of the object.
static hsize_t | getNumMembers (H5I_type_t type)
| Returns the number of members of the given type.
static bool | isValid (hid_t an_id)
| Checks if the given ID is valid.
static bool | typeExists (H5I_type_t type)
| Queries if a given type is currently registered with the library.

## Static Public Attributes
static const ObjCreatPropList & | DEFAULT = *getConstant()
| Default object creation property list.
Static Public Attributes inherited from PropList
static const PropList & | DEFAULT = *getConstant()
| Default property list.

## Additional Inherited Members
Protected Member Functions inherited from PropList
virtual void | p_setId (const hid_t new_id) override
| Sets the identifier of this object to a new value.
Protected Member Functions inherited from IdComponent
| IdComponent ()
| Default constructor.
std::string | p_get_file_name () const
Static Protected Member Functions inherited from IdComponent
static bool | p_valid_id (const hid_t obj_id)
Protected Attributes inherited from PropList
hid_t | id
Static Protected Attributes inherited from IdComponent
static bool | H5dontAtexit_called = false

## Constructor & Destructor Documentation

## ◆ ObjCreatPropList() [1/3]

ObjCreatPropList | ( |  | ) |

Creates a file access property list.

## ◆ ObjCreatPropList() [2/3]

ObjCreatPropList | ( | const ObjCreatPropList & | original | ) |

Copy constructor: same HDF5 object as original.

Parameters

  original | - IN: ObjCreatPropList instance to copy

## ◆ ObjCreatPropList() [3/3]

ObjCreatPropList | ( | const hid_t | plist_id | ) |

Creates a file access property list using the id of an existing one.

## ◆ ~ObjCreatPropList()

virtual ~ObjCreatPropList | ( |  | ) |
| override virtual default

## Member Function Documentation

## ◆ deleteConstants()

void deleteConstants | ( |  | ) |
| static

## ◆ fromClass()

virtual std::string fromClass | ( |  | ) | const
| override virtual

Returns this class name.

Reimplemented from PropList.

Reimplemented in DSetCreatPropList.

## ◆ getAttrCrtOrder()

unsigned getAttrCrtOrder | ( |  | ) | const

Returns the flags indicating creation order is tracked/indexed for attributes on an object.

Returns
  The flags

Exceptions

  H5::PropListIException |

Description
  When no flag is set, i.e. crt_order_flags = 0, attribute creation order is neither tracked not indexed. For detail, please refer to the H5Pget_attr_creation_order API in the HDF5 C Reference Manual.

## ◆ getAttrPhaseChange()

void getAttrPhaseChange | ( | unsigned & | max_compact,
|  | unsigned & | min_dense ) const

Gets attribute storage phase change thresholds.

Parameters

  max_compact | - OUT: Maximum number of attributes to be stored in compact storage.
  min_dense | - OUT: Minimum number of attributes to be stored in dense storage.

Exceptions

  H5::PropListIException |

Description
  If `max_compact` is set to 0, dense storage will be used. For more detail about on attribute storage, please refer to the H5Pget_attr_phase_change API in the HDF5 C Reference Manual.

## ◆ setAttrCrtOrder()

void setAttrCrtOrder | ( | unsigned | crt_order_flags | ) | const

Set the flags for creation order of attributes on an object.

Parameters

  crt_order_flags | - IN: Flags specifying whether to track and index attribute creation order. Default: No flag set

Exceptions

  H5::PropListIException |

Description
  Valid flags are:
  - `H5P_CRT_ORDER_TRACKED` - Attribute creation order is tracked
  - `H5P_CRT_ORDER_INDEXED` - Attribute creation order is indexed (requires H5P_CRT_ORDER_TRACKED). When no flag is set, attribute creation order is neither tracked not indexed. Note that HDF5 currently provides no mechanism to turn on attribute creation order tracking at object creation time and to build the index later. For detail, please refer to the H5Pset_attr_creation_order API in the HDF5 C Reference Manual.

## ◆ setAttrPhaseChange()

void setAttrPhaseChange | ( | unsigned | max_compact = 8,
|  | unsigned | min_dense = 6 ) const

Sets attribute storage phase change thresholds.

Parameters

  max_compact | - IN: Maximum number of attributes to be stored in compact storage. Default to 8
  min_dense | - IN: Minimum number of attributes to be stored in dense storage. Default to 6

Exceptions

  H5::PropListIException |

Description
  If `max_compact` is set to 0, dense storage will be used. For more detail about on attribute storage, please refer to the H5Pset_attr_phase_change API in the HDF5 C Reference Manual.

## Field Documentation

## ◆ DEFAULT

const ObjCreatPropList & DEFAULT = *getConstant()
| static

Default object creation property list.

The documentation for this class was generated from the following files:

- c++/src/H5OcreatProp.h
- c++/src/H5OcreatProp.cpp